
![alt text](https://github.com/pgMemento/pgMemento/blob/master/material/pgmemento_logo.png "pgMemento Logo")


**pgMemento** provides an audit trail for DML and DDL changes inside a PostgreSQL database. The logged information is bound to table events and transactions and not to timestamp fields, which are often used by other audit trail solutions to specify the validity interval of a tuple. Managing logs with transactions allows for rolling back events selectively by keeping the database consistent.

# Key features

* Generic centralized audit trail with old and new JSONB deltas
* Supports schema versioning and logs data changes caused by it
* Clear separation of transactions, events and logged data
* On-the-fly queries of historic tuples
* Reverting previous DML and DDL events
* Restoring of former table or schema states in a separate database schema incl. constraints and indexes
* Logs can be dropped without affecting the versioning mechanism

# Licence

pgMemento is [licensed](https://github.com/pgMemento/pgMemento/blob/master/LICENSE) under the GNU Lesser General Public License (LGPL) v3.

# Disclaimer

pgMemento IS PROVIDED "AS IS" AND "WITH ALL FAULTS." I MAKE NO REPRESENTATIONS OR WARRANTIES OF ANY KIND CONCERNING THE QUALITY, SAFETY OR SUITABILITY OF THE SKRIPTS, EITHER EXPRESSED OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, OR NON-INFRINGEMENT.

IN NO EVENT WILL I BE LIABLE FOR ANY INDIRECT, PUNITIVE, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES HOWEVER THEY MAY ARISE AND EVEN IF I HAVE BEEN PREVIOUSLY ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. STILL, I WOULD FEEL SORRY.
