The `pgmemento.transaction_log` table stores metadata about each transaction. It is filled by the `pgmemento.log_transaction` function (via `pgmemento.log_table_event`) that is called whenever a [table trigger](https://github.com/pgMemento/pgMemento/wiki/DML-logging) or [event trigger](https://github.com/pgMemento/pgMemento/wiki/DDL-logging) is fired. This can happen multiple time during one transaction, but the details are only logged once. The log table contains the following columns:
* `id SERIAL`: The Primary Key
* `txid BIGINT NOT NULL`: The internal transaction ID by PostgreSQL (can cycle)
* `txid_time TIMESTAMP WITH TIME ZONE NOT NULL`: Stores the result of `transaction_timestamp()` function
* `process_id INTEGER`: Stores the result of `pg_backend_pid()` function
* `user_name TEXT`: Stores the result of `current_user` function
* `client_name TEXT`: Stores the result of `inet_client_addr()` function
* `client_port INTEGER`: Stores the result of `inet_client_port()` function
* `application_name TEXT`: Stores the output of `current_setting('application_name')`
* `session_info JSONB`: Stores any infos a client/user defines beforehand with [set_config](https://github.com/pgMemento/pgMemento/wiki/User-defined-session-infos)
